﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Cells;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.UI.Xaml.Grid.Helpers;
using WpfTestingSample.Model;
using Syncfusion.UI.Xaml.ScrollAxis;
using System.Reflection;

namespace WpfTestingSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            datagrid.Loaded += datagrid_Loaded;
        }

        void datagrid_Loaded(object sender, RoutedEventArgs e)
        {
            var row = this.datagrid.GetRowGenerator().Items[0];
            FormattedText formattedtext = null;
            var visibleColumns = row.GetType().GetProperty("VisibleColumns", BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic).GetValue(row, null) as List<DataColumnBase>;

            foreach (var item in visibleColumns)
            {
                double maxheight = 0.0;
                string[] columnNames = item.GridColumn.HeaderText.Split(' ');
                foreach (var columnName in columnNames)
                {
                    formattedtext = new FormattedText(columnName,
                                System.Globalization.CultureInfo.CurrentCulture, datagrid.FlowDirection,
                                new Typeface(datagrid.FontFamily, datagrid.FontStyle, FontWeights.Normal,
                                    new FontStretch()), 14, Brushes.Black);
                    maxheight += formattedtext.Height;
                }
                if (datagrid.HeaderRowHeight < maxheight)
                    datagrid.HeaderRowHeight = maxheight;
            }
        }
        
    }

}
